#include <stdio.h>
#include <stdlib.h>


/*
 * Fonction recursive simple.
 */
unsigned long factoriel (int n)
{
   if (n < 0) {
      exit (EXIT_FAILURE);
   }
   else if (n == 1 || n == 0) {
      return 1L;
   }

   return n * factoriel (n - 1);
}


/*
 * Fonction recursive terminale.
 */
unsigned long factoriel_terminal (int n, unsigned long result)
{
   if (n < 0) {
      exit (EXIT_FAILURE);
   }

   if (n == 1) {
      return result;
   }
   else if (n == 0) {
      return 1L;
   }

   return factoriel_terminal (n - 1, n * result);
}


/*
 * Fonction iterative.
 */
unsigned long factoriel_iterative (unsigned int n)
{
   unsigned long ret = 1;
   unsigned int i = 1;

   for (i = 1; i <= n; i++)
   {
      ret *= i;
   }

   return ret;
}


int main (void)
{
   unsigned long ret = 0;


   /*
    * Recursivite simple.
    */
   ret = factoriel (6);
   printf ("6! = %ld\n", ret);


   /*
    * Recursivite terminale.
    */
   ret = 0;
   ret = factoriel_terminal (6, 1);
   printf ("6! = %ld\n", ret);


   /*
    * Fonction iterative.
    */
   ret = 0;
   ret = factoriel_iterative (6);
   printf ("6! = %ld\n", ret);


   return EXIT_SUCCESS;
}
